<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Magnifying Glass Effect</title>
    <style>
        body {
            margin: 0;
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
            background-color: #f0f0f0;
        }

        .container {
            position: relative;
        }

        .image {
            display: block;
            max-width: 100%;
            height: auto;
        }

        .magnifier {
            position: absolute;
            border: 3px solid #000;
            border-radius: 50%;
            cursor: none;
            width: 150px;
            height: 150px;
            overflow: hidden;
            box-shadow: 0 0 5px rgba(0, 0, 0, 0.3);
            display: none; /* Initially hidden */
            background-color: white;
        }

        .magnifier img {
            position: absolute;
            width: 200%; /* Adjust for the zoom level */
        }
    </style>
</head>
<body>
    <div class="container">
        <img src="https://via.placeholder.com/800" alt="Image to magnify" class="image">
        <div class="magnifier"></div>
    </div>
    <script>
        document.addEventListener('DOMContentLoaded', () => {
            const magnifier = document.querySelector('.magnifier');
            const image = document.querySelector('.image');

            image.addEventListener('mousemove', (event) => {
                const { offsetX, offsetY } = event;
                const { width, height } = image.getBoundingClientRect();
                const magnifierWidth = magnifier.offsetWidth;
                const magnifierHeight = magnifier.offsetHeight;

                // Show the magnifier
                magnifier.style.display = 'block';

                // Calculate the position of the magnifier
                let x = offsetX - magnifierWidth / 2;
                let y = offsetY - magnifierHeight / 2;

                // Ensure the magnifier stays within the image bounds
                if (x < 0) x = 0;
                if (y < 0) y = 0;
                if (x > width - magnifierWidth) x = width - magnifierWidth;
                if (y > height - magnifierHeight) y = height - magnifierHeight;

                // Position the magnifier

                magnifier.style.backgroundColor = `#ffffff`;
                magnifier.style.left = `${x}px`;
                magnifier.style.top = `${y}px`;

                // Position the background image within the magnifier
                const zoomLevel = 2; // Match the CSS width adjustment for zoom level
                magnifier.style.backgroundImage = `url(${image.src})`;
                magnifier.style.backgroundRepeat = 'no-repeat';
                magnifier.style.backgroundSize = `${width * zoomLevel}px ${height * zoomLevel}px`;
                magnifier.style.backgroundPosition = `-${x * zoomLevel}px -${y * zoomLevel}px`;
            });

            image.addEventListener('mouseleave', () => {
                // Hide the magnifier when the mouse leaves the image
                magnifier.style.display = 'none';
            });
        });
    </script>
</body>
</html>
